window.Gleam.initSearch([{"doc":"carotte","title":"carotte","content":"# 🥕 Carotte\n\n## A RabbitMQ client for Gleam\n\n[![Package Version](https://img.shields.io/hexpm/v/candy)](https://hex.pm/packages/candy)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/candy/)\n\n```sh\ngleam add carotte\n```\n\n```gleam\nimport candy\n\npub fn main() {\n  let assert Ok(client) =\n    carotte.default_client()\n    |&gt; carotte.start()\n\n  let assert Ok(channel) =\n    channel.open_channel(client)\n\n  exchange.new(&quot;consume_exchange&quot;)\n  |&gt; exchange.declare(channel)\n  queue.new(&quot;consume_queue&quot;)\n  |&gt; queue.declare(channel)\n\n  queue.bind(\n    channel: channel,\n    queue: &quot;consume_queue&quot;,\n    exchange: &quot;consume_exchange&quot;,\n    routing_key: &quot;&quot;,\n  )\n\n  publisher.publish(\n    channel: channel,\n    exchange: &quot;consume_exchange&quot;,\n    routing_key: &quot;&quot;,\n    payload: &quot;payload&quot;,\n    options: [],\n  )\n\n  queue.subscribe(\n    channel: channel,\n    queue: &quot;consume_queue&quot;,\n    callback: fn(payload, _) {\n      payload.payload\n      |&gt; should.equal(&quot;payload&quot;)\n    },\n  )\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/candy&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\n```\n","url":"index.html"},{"doc":"carotte","title":"Builder","content":"pub opaque type Builder\n\n\nSynonyms:\ncarotte.Builder\ncarotte Builder","url":"carotte.html#Builder"},{"doc":"carotte","title":"CarotteClient","content":"pub type CarotteClient {\n  CarotteClient(pid: Pid)\n}\n\nCarotteClient(pid: Pid)\n\n\nSynonyms:\ncarotte.CarotteClient\ncarotte CarotteClient","url":"carotte.html#CarotteClient"},{"doc":"carotte","title":"CarotteError","content":"pub type CarotteError {\n  Blocked\n  Closed\n}\n\nBlocked\n\n\nClosed\n\n\nSynonyms:\ncarotte.CarotteError\ncarotte CarotteError","url":"carotte.html#CarotteError"},{"doc":"carotte","title":"close","content":"pub fn close(client: CarotteClient) -&gt; Result(Nil, CarotteError)\n\nSynonyms:\ncarotte.close\ncarotte close","url":"carotte.html#close"},{"doc":"carotte","title":"default_client","content":"pub fn default_client() -&gt; Builder\n\nSynonyms:\ncarotte.default_client\ncarotte default_client","url":"carotte.html#default_client"},{"doc":"carotte","title":"start","content":"pub fn start(\n  builder: Builder,\n) -&gt; Result(CarotteClient, CarotteError)\n\nSynonyms:\ncarotte.start\ncarotte start","url":"carotte.html#start"},{"doc":"carotte","title":"with_channel_max","content":"pub fn with_channel_max(\n  builder: Builder,\n  channel_max: Int,\n) -&gt; Builder\n\nSynonyms:\ncarotte.with_channel_max\ncarotte with_channel_max","url":"carotte.html#with_channel_max"},{"doc":"carotte","title":"with_connection_timeout","content":"pub fn with_connection_timeout(\n  builder: Builder,\n  connection_timeout: Int,\n) -&gt; Builder\n\nSynonyms:\ncarotte.with_connection_timeout\ncarotte with_connection_timeout","url":"carotte.html#with_connection_timeout"},{"doc":"carotte","title":"with_frame_max","content":"pub fn with_frame_max(\n  builder: Builder,\n  frame_max: Int,\n) -&gt; Builder\n\nSynonyms:\ncarotte.with_frame_max\ncarotte with_frame_max","url":"carotte.html#with_frame_max"},{"doc":"carotte","title":"with_heartbeat","content":"pub fn with_heartbeat(\n  builder: Builder,\n  heartbeat: Int,\n) -&gt; Builder\n\nSynonyms:\ncarotte.with_heartbeat\ncarotte with_heartbeat","url":"carotte.html#with_heartbeat"},{"doc":"carotte","title":"with_host","content":"pub fn with_host(builder: Builder, host: String) -&gt; Builder\n\nSynonyms:\ncarotte.with_host\ncarotte with_host","url":"carotte.html#with_host"},{"doc":"carotte","title":"with_password","content":"pub fn with_password(\n  builder: Builder,\n  password: String,\n) -&gt; Builder\n\nSynonyms:\ncarotte.with_password\ncarotte with_password","url":"carotte.html#with_password"},{"doc":"carotte","title":"with_port","content":"pub fn with_port(builder: Builder, port: Int) -&gt; Builder\n\nSynonyms:\ncarotte.with_port\ncarotte with_port","url":"carotte.html#with_port"},{"doc":"carotte","title":"with_username","content":"pub fn with_username(\n  builder: Builder,\n  username: String,\n) -&gt; Builder\n\nSynonyms:\ncarotte.with_username\ncarotte with_username","url":"carotte.html#with_username"},{"doc":"carotte","title":"with_virtual_host","content":"pub fn with_virtual_host(\n  builder: Builder,\n  virtual_host: String,\n) -&gt; Builder\n\nSynonyms:\ncarotte.with_virtual_host\ncarotte with_virtual_host","url":"carotte.html#with_virtual_host"},{"doc":"carotte","title":"carotte","content":"","url":"carotte.html"},{"doc":"carotte/channel","title":"Channel","content":"pub type Channel {\n  Channel(pid: Pid)\n}\n\nChannel(pid: Pid)\n\n\nSynonyms:\ncarotte/channel.Channel\ncarotte/channel Channel","url":"carotte/channel.html#Channel"},{"doc":"carotte/channel","title":"open_channel","content":"pub fn open_channel(\n  candy_client: CarotteClient,\n) -&gt; Result(Channel, CarotteError)\n Open a channel to a RabbitMQ server\nSynonyms:\ncarotte/channel.open_channel\ncarotte/channel open_channel","url":"carotte/channel.html#open_channel"},{"doc":"carotte/channel","title":"carotte/channel","content":"","url":"carotte/channel.html"},{"doc":"carotte/exchange","title":"Exchange","content":"pub opaque type Exchange\n\n\nSynonyms:\ncarotte/exchange.Exchange\ncarotte/exchange Exchange","url":"carotte/exchange.html#Exchange"},{"doc":"carotte/exchange","title":"ExchangeType","content":"pub type ExchangeType {\n  Fanout\n  Direct\n  Topic\n  Headers\n}\n\nFanout\n\n\nDirect\n\n\nTopic\n\n\nHeaders\n\n\nSynonyms:\ncarotte/exchange.ExchangeType\ncarotte/exchange ExchangeType","url":"carotte/exchange.html#ExchangeType"},{"doc":"carotte/exchange","title":"as_durable","content":"pub fn as_durable(exchange: Exchange) -&gt; Exchange\n If set, the exchange will survive a broker restart\nSynonyms:\ncarotte/exchange.as_durable\ncarotte/exchange as_durable","url":"carotte/exchange.html#as_durable"},{"doc":"carotte/exchange","title":"as_internal","content":"pub fn as_internal(exchange: Exchange) -&gt; Exchange\n If set, the exchange may not be used directly by publishers, but only when bound to other exchanges.\n Internal exchanges are used to construct wiring that is not visible to applications\nSynonyms:\ncarotte/exchange.as_internal\ncarotte/exchange as_internal","url":"carotte/exchange.html#as_internal"},{"doc":"carotte/exchange","title":"bind","content":"pub fn bind(\n  channel channel: Channel,\n  source source: String,\n  destination destination: String,\n  routing_key routing_key: String,\n) -&gt; Result(Nil, CarotteError)\n Bind an exchange to another exchange\n Routing keys are used to filter messages from the source exchange\nSynonyms:\ncarotte/exchange.bind\ncarotte/exchange bind","url":"carotte/exchange.html#bind"},{"doc":"carotte/exchange","title":"bind_async","content":"pub fn bind_async(\n  channel channel: Channel,\n  source source: String,\n  destination destination: String,\n  routing_key routing_key: String,\n) -&gt; Result(Nil, CarotteError)\n\nSynonyms:\ncarotte/exchange.bind_async\ncarotte/exchange bind_async","url":"carotte/exchange.html#bind_async"},{"doc":"carotte/exchange","title":"declare","content":"pub fn declare(\n  exchange: Exchange,\n  channel: Channel,\n) -&gt; Result(Nil, CarotteError)\n Declare an exchange on the broker\nSynonyms:\ncarotte/exchange.declare\ncarotte/exchange declare","url":"carotte/exchange.html#declare"},{"doc":"carotte/exchange","title":"declare_async","content":"pub fn declare_async(\n  exchange: Exchange,\n  channel: Channel,\n) -&gt; Result(Nil, CarotteError)\n Declare an exchange on the broker without waiting for a response\nSynonyms:\ncarotte/exchange.declare_async\ncarotte/exchange declare_async","url":"carotte/exchange.html#declare_async"},{"doc":"carotte/exchange","title":"delete","content":"pub fn delete(\n  channel channel: Channel,\n  exchange exchange: String,\n  if_unused unused: Bool,\n) -&gt; Result(Nil, CarotteError)\n Delete an exchange from the broker\n If `unused` is set to true, the exchange will only be deleted if it has no queues bound to it\nSynonyms:\ncarotte/exchange.delete\ncarotte/exchange delete","url":"carotte/exchange.html#delete"},{"doc":"carotte/exchange","title":"delete_async","content":"pub fn delete_async(\n  channel channel: Channel,\n  exchange exchange: String,\n  unused unused: Bool,\n) -&gt; Result(Nil, CarotteError)\n Delete an exchange from the broker without waiting for a response\nSynonyms:\ncarotte/exchange.delete_async\ncarotte/exchange delete_async","url":"carotte/exchange.html#delete_async"},{"doc":"carotte/exchange","title":"new","content":"pub fn new(name: String) -&gt; Exchange\n Create a new exchange with the given name\n Defaults to a direct exchange\nSynonyms:\ncarotte/exchange.new\ncarotte/exchange new","url":"carotte/exchange.html#new"},{"doc":"carotte/exchange","title":"unbind","content":"pub fn unbind(\n  channel channel: Channel,\n  source source: String,\n  destination destination: String,\n  routing_key routing_key: String,\n) -&gt; Result(Nil, CarotteError)\n Unbind an exchange from another exchange\nSynonyms:\ncarotte/exchange.unbind\ncarotte/exchange unbind","url":"carotte/exchange.html#unbind"},{"doc":"carotte/exchange","title":"unbind_async","content":"pub fn unbind_async(\n  channel channel: Channel,\n  source source: String,\n  destination destination: String,\n  routing_key routing_key: String,\n) -&gt; Result(Nil, CarotteError)\n Unbind an exchange from another exchange asynchronously. Same semantics as `unbind`\nSynonyms:\ncarotte/exchange.unbind_async\ncarotte/exchange unbind_async","url":"carotte/exchange.html#unbind_async"},{"doc":"carotte/exchange","title":"with_auto_delete","content":"pub fn with_auto_delete(exchange: Exchange) -&gt; Exchange\n If set, the exchange will be deleted when the last queue is unbound from it\nSynonyms:\ncarotte/exchange.with_auto_delete\ncarotte/exchange with_auto_delete","url":"carotte/exchange.html#with_auto_delete"},{"doc":"carotte/exchange","title":"with_type","content":"pub fn with_type(\n  exchange: Exchange,\n  exchange_type: ExchangeType,\n) -&gt; Exchange\n Give the exchange a type: fanout, direct, topic, or headers\nSynonyms:\ncarotte/exchange.with_type\ncarotte/exchange with_type","url":"carotte/exchange.html#with_type"},{"doc":"carotte/exchange","title":"carotte/exchange","content":"","url":"carotte/exchange.html"},{"doc":"carotte/publisher","title":"PublishOption","content":"pub type PublishOption {\n  Mandatory(Bool)\n  ContentType(String)\n  ContentEncoding(String)\n  Persistent(Bool)\n  CorrelationId(String)\n  Priority(Int)\n  ReplyTo(String)\n  Expiration(String)\n  MessageId(String)\n  Timestamp(Int)\n  Type(String)\n  UserId(String)\n  AppId(String)\n}\n\nMandatory(Bool)\n If set, returns an error if the broker can&#39;t route the message to a queue\n\nContentType(String)\n MIME Content type\n\nContentEncoding(String)\n MIME Content encoding\n\nPersistent(Bool)\n If set, uses persistent delivery mode. \n Messages marked as persistent that are delivered to durable queues will be logged to disk\n\nCorrelationId(String)\n Arbitrary application-specific message identifier\n\nPriority(Int)\n Message priority, ranging from 0 to 9\n\nReplyTo(String)\n Name of the reply queue\n\nExpiration(String)\n How long the message is valid (in milliseconds)\n\nMessageId(String)\n Message identifier\n\nTimestamp(Int)\n timestamp associated with this message (epoch time)\n\nType(String)\n Message type\n\nUserId(String)\n Creating user ID. RabbitMQ will validate this against the active connection user\n\nAppId(String)\n Application ID\n\nSynonyms:\ncarotte/publisher.PublishOption\ncarotte/publisher PublishOption","url":"carotte/publisher.html#PublishOption"},{"doc":"carotte/publisher","title":"publish","content":"pub fn publish(\n  channel channel: Channel,\n  exchange exchange: String,\n  routing_key routing_key: String,\n  payload payload: String,\n  options options: List(PublishOption),\n) -&gt; Result(Nil, CarotteError)\n Publish a message &#39;payload&#39; to an exchange\n The `routing_key` is used to filter messages from the exchange\n The `options` are used to set message properties\nSynonyms:\ncarotte/publisher.publish\ncarotte/publisher publish","url":"carotte/publisher.html#publish"},{"doc":"carotte/publisher","title":"carotte/publisher","content":"","url":"carotte/publisher.html"},{"doc":"carotte/queue","title":"DeclaredQueue","content":"pub type DeclaredQueue {\n  DeclaredQueue(\n    name: String,\n    message_count: Int,\n    consumer_count: Int,\n  )\n}\n\nDeclaredQueue(\n  name: String,\n  message_count: Int,\n  consumer_count: Int,\n)\n\n\nSynonyms:\ncarotte/queue.DeclaredQueue\ncarotte/queue DeclaredQueue","url":"carotte/queue.html#DeclaredQueue"},{"doc":"carotte/queue","title":"Deliver","content":"pub type Deliver {\n  Deliver(\n    consumer_tag: String,\n    delivery_tag: Int,\n    redelivered: Bool,\n    exchange: String,\n    routing_key: String,\n  )\n}\n\nDeliver(\n  consumer_tag: String,\n  delivery_tag: Int,\n  redelivered: Bool,\n  exchange: String,\n  routing_key: String,\n)\n\n\nSynonyms:\ncarotte/queue.Deliver\ncarotte/queue Deliver","url":"carotte/queue.html#Deliver"},{"doc":"carotte/queue","title":"Payload","content":"pub type Payload {\n  Payload(\n    payload: String,\n    properties: List(publisher.PublishOption),\n  )\n}\n\nPayload(\n  payload: String,\n  properties: List(publisher.PublishOption),\n)\n\n\nSynonyms:\ncarotte/queue.Payload\ncarotte/queue Payload","url":"carotte/queue.html#Payload"},{"doc":"carotte/queue","title":"Queue","content":"pub opaque type Queue\n\n\nSynonyms:\ncarotte/queue.Queue\ncarotte/queue Queue","url":"carotte/queue.html#Queue"},{"doc":"carotte/queue","title":"add_if_some","content":"pub fn add_if_some(\n  list: List(a),\n  constructor: fn(b) -&gt; a,\n  value: Option(b),\n) -&gt; List(a)\n\nSynonyms:\ncarotte/queue.add_if_some\ncarotte/queue add_if_some","url":"carotte/queue.html#add_if_some"},{"doc":"carotte/queue","title":"as_durable","content":"pub fn as_durable(queue: Queue) -&gt; Queue\n If set, the queue will survive a broker restart\nSynonyms:\ncarotte/queue.as_durable\ncarotte/queue as_durable","url":"carotte/queue.html#as_durable"},{"doc":"carotte/queue","title":"as_exclusive","content":"pub fn as_exclusive(queue: Queue) -&gt; Queue\n If set, only one subscriber can consume from the Queue\nSynonyms:\ncarotte/queue.as_exclusive\ncarotte/queue as_exclusive","url":"carotte/queue.html#as_exclusive"},{"doc":"carotte/queue","title":"as_passive","content":"pub fn as_passive(queue: Queue) -&gt; Queue\n If set, the queue must already exist on the broker\nSynonyms:\ncarotte/queue.as_passive\ncarotte/queue as_passive","url":"carotte/queue.html#as_passive"},{"doc":"carotte/queue","title":"bind","content":"pub fn bind(\n  channel channel: Channel,\n  queue queue: String,\n  exchange exchange: String,\n  routing_key routing_key: String,\n) -&gt; Result(Nil, CarotteError)\n Bind a queue to an exchange\n The `routing_key` is used to filter messages from the exchange\nSynonyms:\ncarotte/queue.bind\ncarotte/queue bind","url":"carotte/queue.html#bind"},{"doc":"carotte/queue","title":"bind_async","content":"pub fn bind_async(\n  channel channel: Channel,\n  queue queue: String,\n  exchange exchange: String,\n  routing_key routing_key: String,\n) -&gt; Result(Nil, CarotteError)\n Bind a queue to an exchange asynchronously. Same semantics as `bind`\nSynonyms:\ncarotte/queue.bind_async\ncarotte/queue bind_async","url":"carotte/queue.html#bind_async"},{"doc":"carotte/queue","title":"declare","content":"pub fn declare(\n  queue: Queue,\n  channel: Channel,\n) -&gt; Result(DeclaredQueue, CarotteError)\n Declare a queue on the broker\nSynonyms:\ncarotte/queue.declare\ncarotte/queue declare","url":"carotte/queue.html#declare"},{"doc":"carotte/queue","title":"declare_async","content":"pub fn declare_async(\n  queue: Queue,\n  channel: Channel,\n) -&gt; Result(Nil, CarotteError)\n Declare a queue on the broker asynchronously\nSynonyms:\ncarotte/queue.declare_async\ncarotte/queue declare_async","url":"carotte/queue.html#declare_async"},{"doc":"carotte/queue","title":"delete","content":"pub fn delete(\n  channel channel: Channel,\n  queue queue: String,\n  if_unused if_unused: Bool,\n  if_empty if_empty: Bool,\n) -&gt; Result(Int, CarotteError)\n Delete a queue from the broker\n If `if_unused` is set, the queue will only be deleted if it has no subscribers\n If `if_empty` is set, the queue will only be deleted if it has no messages\nSynonyms:\ncarotte/queue.delete\ncarotte/queue delete","url":"carotte/queue.html#delete"},{"doc":"carotte/queue","title":"delete_async","content":"pub fn delete_async(\n  channel channel: Channel,\n  queue queue: String,\n  if_unused if_unused: Bool,\n  if_empty if_empty: Bool,\n) -&gt; Result(Nil, CarotteError)\n Delete a queue from the broker asynchronously. Same semantics as `delete`\nSynonyms:\ncarotte/queue.delete_async\ncarotte/queue delete_async","url":"carotte/queue.html#delete_async"},{"doc":"carotte/queue","title":"new","content":"pub fn new(name: String) -&gt; Queue\n Create a new queue with the given name\nSynonyms:\ncarotte/queue.new\ncarotte/queue new","url":"carotte/queue.html#new"},{"doc":"carotte/queue","title":"purge","content":"pub fn purge(\n  channel channel: Channel,\n  queue queue: String,\n) -&gt; Result(Int, CarotteError)\n Purge a queue of all messages\nSynonyms:\ncarotte/queue.purge\ncarotte/queue purge","url":"carotte/queue.html#purge"},{"doc":"carotte/queue","title":"purge_async","content":"pub fn purge_async(\n  channel channel: Channel,\n  queue queue: String,\n) -&gt; Result(Nil, CarotteError)\n Purge a queue of all messages asynchronously\nSynonyms:\ncarotte/queue.purge_async\ncarotte/queue purge_async","url":"carotte/queue.html#purge_async"},{"doc":"carotte/queue","title":"status","content":"pub fn status(\n  channel channel: Channel,\n  queue queue: String,\n) -&gt; Result(DeclaredQueue, CarotteError)\n Get the status of a queue\nSynonyms:\ncarotte/queue.status\ncarotte/queue status","url":"carotte/queue.html#status"},{"doc":"carotte/queue","title":"subscribe","content":"pub fn subscribe(\n  channel channel: Channel,\n  queue queue: String,\n  callback fun: fn(Payload, Deliver) -&gt; Nil,\n) -&gt; Result(String, CarotteError)\n Subscribe to a queue\n The `callback` function will be called with each message received, receiving the message Payload and a `Deliver` struct\nSynonyms:\ncarotte/queue.subscribe\ncarotte/queue subscribe","url":"carotte/queue.html#subscribe"},{"doc":"carotte/queue","title":"unbind","content":"pub fn unbind(\n  channel channel: Channel,\n  queue queue: String,\n  exchange exchange: String,\n  routing_key routing_key: String,\n) -&gt; Result(Nil, CarotteError)\n Unbind a queue from an exchange\n The `routing_key` is used to filter messages from the exchange\nSynonyms:\ncarotte/queue.unbind\ncarotte/queue unbind","url":"carotte/queue.html#unbind"},{"doc":"carotte/queue","title":"unsubscribe","content":"pub fn unsubscribe(\n  channel channel: Channel,\n  consumer_tag consumer_tag: String,\n) -&gt; Result(Nil, CarotteError)\n Unsubscribe a consumer from a queue\nSynonyms:\ncarotte/queue.unsubscribe\ncarotte/queue unsubscribe","url":"carotte/queue.html#unsubscribe"},{"doc":"carotte/queue","title":"unsubscribe_async","content":"pub fn unsubscribe_async(\n  channel channel: Channel,\n  consumer_tag consumer_tag: String,\n) -&gt; Result(Nil, CarotteError)\n Unsubscribe a consumer from a queue asynchronously\nSynonyms:\ncarotte/queue.unsubscribe_async\ncarotte/queue unsubscribe_async","url":"carotte/queue.html#unsubscribe_async"},{"doc":"carotte/queue","title":"with_auto_delete","content":"pub fn with_auto_delete(queue: Queue) -&gt; Queue\n If set, the queue will be deleted when the last subscriber disconnect\nSynonyms:\ncarotte/queue.with_auto_delete\ncarotte/queue with_auto_delete","url":"carotte/queue.html#with_auto_delete"},{"doc":"carotte/queue","title":"carotte/queue","content":"","url":"carotte/queue.html"}]);